/* Default linker script, for normal executables */
OUTPUT_FORMAT("elf32-avr32", "elf32-avr32", "elf32-avr32")
OUTPUT_ARCH(avr32:ap)
ENTRY(_start)
SEARCH_DIR("/home/mingwbuild/mingwavr32/avr32/lib");
/* Do we need any of these for elf?
   __DYNAMIC = 0;    */
   
MEMORY
  {
  	FLASH (rxai)     : ORIGIN = 0x00000000, LENGTH = 8M
	HFLASH (rxai)    : ORIGIN = 0xA0000000, LENGTH = 8M
	
	CPUSRAM (rwxa)   : ORIGIN = 0x24000000, LENGTH = 32K
	SDRAM   (rwxa)   : ORIGIN = 0x10000000, LENGTH = 32M	
  }
SECTIONS
{
  /* Read-only sections, merged into text segment: */
  PROVIDE (__executable_start = 0xa0000000); . = 0xa0000000;
  .interp         : { *(.interp) } >HFLASH AT>FLASH
  .reset : {  *(.reset) } >HFLASH AT>FLASH
    . = . & 0x9fffffff;
  .hash           : { *(.hash) } >HFLASH AT>FLASH
  .dynsym         : { *(.dynsym) } >HFLASH AT>FLASH
  .dynstr         : { *(.dynstr) } >HFLASH AT>FLASH
  .gnu.version    : { *(.gnu.version) } >HFLASH AT>FLASH
  .gnu.version_d  : { *(.gnu.version_d) } >HFLASH AT>FLASH
  .gnu.version_r  : { *(.gnu.version_r) } >HFLASH AT>FLASH
  .rel.init       : { *(.rel.init) } >HFLASH AT>FLASH
  .rela.init      : { *(.rela.init) } >HFLASH AT>FLASH
  .rel.text       : { *(.rel.text .rel.text.* .rel.gnu.linkonce.t.*) } >HFLASH AT>FLASH
  .rela.text      : { *(.rela.text .rela.text.* .rela.gnu.linkonce.t.*) } >HFLASH AT>FLASH
  .rel.fini       : { *(.rel.fini) } >HFLASH AT>FLASH
  .rela.fini      : { *(.rela.fini) } >HFLASH AT>FLASH
  .rel.rodata     : { *(.rel.rodata .rel.rodata.* .rel.gnu.linkonce.r.*) } >HFLASH AT>FLASH
  .rela.rodata    : { *(.rela.rodata .rela.rodata.* .rela.gnu.linkonce.r.*) } >HFLASH AT>FLASH
  .rel.data.rel.ro   : { *(.rel.data.rel.ro*) } >HFLASH AT>FLASH
  .rela.data.rel.ro   : { *(.rel.data.rel.ro*) } >HFLASH AT>FLASH
  .rel.data       : { *(.rel.data .rel.data.* .rel.gnu.linkonce.d.*) } >HFLASH AT>FLASH
  .rela.data      : { *(.rela.data .rela.data.* .rela.gnu.linkonce.d.*) } >HFLASH AT>FLASH
  .rel.tdata	  : { *(.rel.tdata .rel.tdata.* .rel.gnu.linkonce.td.*) } >HFLASH AT>FLASH
  .rela.tdata	  : { *(.rela.tdata .rela.tdata.* .rela.gnu.linkonce.td.*) } >HFLASH AT>FLASH
  .rel.tbss	  : { *(.rel.tbss .rel.tbss.* .rel.gnu.linkonce.tb.*) } >HFLASH AT>FLASH
  .rela.tbss	  : { *(.rela.tbss .rela.tbss.* .rela.gnu.linkonce.tb.*) } >HFLASH AT>FLASH
  .rel.ctors      : { *(.rel.ctors) } >HFLASH AT>FLASH
  .rela.ctors     : { *(.rela.ctors) } >HFLASH AT>FLASH
  .rel.dtors      : { *(.rel.dtors) } >HFLASH AT>FLASH
  .rela.dtors     : { *(.rela.dtors) } >HFLASH AT>FLASH
  .rel.got        : { *(.rel.got) } >HFLASH AT>FLASH
  .rela.got       : { *(.rela.got) } >HFLASH AT>FLASH
  .rel.bss        : { *(.rel.bss .rel.bss.* .rel.gnu.linkonce.b.*) } >HFLASH AT>FLASH
  .rela.bss       : { *(.rela.bss .rela.bss.* .rela.gnu.linkonce.b.*) } >HFLASH AT>FLASH
  .rel.plt        : { *(.rel.plt) } >HFLASH AT>FLASH
  .rela.plt       : { *(.rela.plt) } >HFLASH AT>FLASH
  .init           :
  {
    KEEP (*(.init))
  } >HFLASH AT>FLASH =0xd703d703
  .plt            : { *(.plt) } >HFLASH AT>FLASH
  .text           :
  {
    *(.text .stub .text.* .gnu.linkonce.t.*)
    KEEP (*(.text.*personality*))
    /* .gnu.warning sections are handled specially by elf32.em.  */
    *(.gnu.warning)
  } >HFLASH AT>FLASH =0xd703d703  
  .fini           :
  {
    KEEP (*(.fini))
  } >HFLASH AT>FLASH =0xd703d703
  PROVIDE (__etext = .);
  PROVIDE (_etext = .);
  PROVIDE (etext = .);
  .rodata         : { *(.rodata .rodata.* .gnu.linkonce.r.*) } >HFLASH AT>FLASH
  .rodata1        : { *(.rodata1) } >HFLASH AT>FLASH
  .eh_frame_hdr : { *(.eh_frame_hdr) } >HFLASH AT>FLASH
  .eh_frame       : ONLY_IF_RO { KEEP (*(.eh_frame)) } >HFLASH AT>FLASH
  .gcc_except_table  :  ONLY_IF_RO
  { 
    . = ALIGN(0x1000);
  	KEEP (*(.gcc_except_table)) *(.gcc_except_table.*) 
  } >HFLASH AT>FLASH
       
  .dalign	: 
  { 
  	. = ALIGN(8); 
  	PROVIDE(_data_lma = .); 
  } >HFLASH AT>FLASH
  
  PROVIDE (_data = ORIGIN(SDRAM));
  . = ORIGIN(SDRAM);
  /* Exception handling  */
  .eh_frame       : ONLY_IF_RW { KEEP (*(.eh_frame)) } >SDRAM AT>FLASH
  .gcc_except_table   : ONLY_IF_RW 
  { 
  	KEEP (*(.gcc_except_table)) *(.gcc_except_table.*) 
  } >SDRAM AT>FLASH
  
  /*
  
  .proc : 
  {
  	*(.processes)
  } >FLASH2 AT>FLASH2
  
  */
  
  /* Thread Local Storage sections  */
  .tdata	  : { *(.tdata .tdata.* .gnu.linkonce.td.*) } >SDRAM AT>FLASH
  .tbss		  : { *(.tbss .tbss.* .gnu.linkonce.tb.*) *(.tcommon) } >SDRAM AT>FLASH
  /* Ensure the __preinit_array_start label is properly aligned.  We
     could instead move the label definition inside the section, but
     the linker would then create the section even if it turns out to
     be empty, which isn't pretty.  */
  PROVIDE (__preinit_array_start = ALIGN(32 / 8));
  .preinit_array     : { KEEP (*(.preinit_array)) } >SDRAM AT>FLASH
  PROVIDE (__preinit_array_end = .);
  PROVIDE (__init_array_start = .);
  .init_array     : { KEEP (*(.init_array)) } >SDRAM AT>FLASH
  PROVIDE (__init_array_end = .);
  PROVIDE (__fini_array_start = .);
  .fini_array     : { KEEP (*(.fini_array)) } >SDRAM AT>FLASH
  PROVIDE (__fini_array_end = .);
  .ctors          :
  {
    /* gcc uses crtbegin.o to find the start of
       the constructors, so we make sure it is
       first.  Because this is a wildcard, it
       doesn't matter if the user does not
       actually link against crtbegin.o; the
       linker won't look for a file to match a
       wildcard.  The wildcard also means that it
       doesn't matter which directory crtbegin.o
       is in.  */
    KEEP (*crtbegin*.o(.ctors))
    /* We don't want to include the .ctor section from
       from the crtend.o file until after the sorted ctors.
       The .ctor section from the crtend file contains the
       end of ctors marker and it must be last */
    KEEP (*(EXCLUDE_FILE (*crtend*.o ) .ctors))
    KEEP (*(SORT(.ctors.*)))
    KEEP (*(.ctors))
  } >SDRAM AT>FLASH
  .dtors          :
  {
    KEEP (*crtbegin*.o(.dtors))
    KEEP (*(EXCLUDE_FILE (*crtend*.o ) .dtors))
    KEEP (*(SORT(.dtors.*)))
    KEEP (*(.dtors))
  } >SDRAM AT>FLASH
  .jcr            : { KEEP (*(.jcr)) } >SDRAM AT>FLASH
  .data.rel.ro : { *(.data.rel.ro.local) *(.data.rel.ro*) } >SDRAM AT>FLASH
  .dynamic        : { *(.dynamic) } >SDRAM AT>FLASH
  .got            : { *(.got.plt) *(.got) } >SDRAM AT>FLASH
  .data           :
  {
    *(.data .data.* .gnu.linkonce.d.*)
    KEEP (*(.gnu.linkonce.d.*personality*))
    SORT(CONSTRUCTORS)
  } >SDRAM AT>FLASH
  .data1          : { *(.data1) } >SDRAM AT>FLASH
  .balign	: { . = ALIGN(8); _edata = .; } >SDRAM AT>FLASH
  _edata = .;
  PROVIDE (edata = .);
  __bss_start = .;
  .bss            :
  {
   *(.dynbss)
   *(.bss .bss.* .gnu.linkonce.b.*)
   *(COMMON)
   /* Align here to ensure that the .bss section occupies space up to
      _end.  Align after .bss to ensure correct alignment even if the
      .bss section disappears because there are no input sections.  */
   . = ALIGN(8);
  } >SDRAM AT>FLASH
  . = ALIGN(8);
  _end = .;
  PROVIDE (end = .); 
  __heap_start__ = ALIGN(8);
  . = ORIGIN(SDRAM) + LENGTH(SDRAM) - 0x1000;
  __heap_end__ = .;
  /* Stabs debugging sections.  */
  .stab          0 : { *(.stab) }
  .stabstr       0 : { *(.stabstr) }
  .stab.excl     0 : { *(.stab.excl) }
  .stab.exclstr  0 : { *(.stab.exclstr) }
  .stab.index    0 : { *(.stab.index) }
  .stab.indexstr 0 : { *(.stab.indexstr) }
  .comment       0 : { *(.comment) }
  /* DWARF debug sections.
     Symbols in the DWARF debugging sections are relative to the beginning
     of the section so we begin them at 0.  */
  /* DWARF 1 */
  .debug          0 : { *(.debug) }
  .line           0 : { *(.line) }
  /* GNU DWARF 1 extensions */
  .debug_srcinfo  0 : { *(.debug_srcinfo) }
  .debug_sfnames  0 : { *(.debug_sfnames) }
  /* DWARF 1.1 and DWARF 2 */
  .debug_aranges  0 : { *(.debug_aranges) }
  .debug_pubnames 0 : { *(.debug_pubnames) }
  /* DWARF 2 */
  .debug_info     0 : { *(.debug_info .gnu.linkonce.wi.*) }
  .debug_abbrev   0 : { *(.debug_abbrev) }
  .debug_line     0 : { *(.debug_line) }
  .debug_frame    0 : { *(.debug_frame) }
  .debug_str      0 : { *(.debug_str) }
  .debug_loc      0 : { *(.debug_loc) }
  .debug_macinfo  0 : { *(.debug_macinfo) }
  /* SGI/MIPS DWARF 2 extensions */
  .debug_weaknames 0 : { *(.debug_weaknames) }
  .debug_funcnames 0 : { *(.debug_funcnames) }
  .debug_typenames 0 : { *(.debug_typenames) }
  .debug_varnames  0 : { *(.debug_varnames) }
  
  .hstack	ORIGIN(SDRAM) + LENGTH(SDRAM) - 0x1000 :
  {
    _hstack = .;
    *(.stack)
    . = 0x1000;
    _hestack = .;
  } >SDRAM AT>FLASH

    .stack	ORIGIN(CPUSRAM) + LENGTH(CPUSRAM) - 0x1000 :
  {
    _stack = .;
    *(.stack)
    . = 0x1000;
    _estack = .;
  } >CPUSRAM AT>FLASH
  /DISCARD/ : { *(.note.GNU-stack) }
}
